package com.cneeds.notouch;

import com.cneeds.notouch.bean.CoordinateBean;

import java.util.ArrayList;
import java.util.List;

public class NoTouchParam {

    private final int SPECIAL_FLAG;
    private final int FOCUS_STATUS;
    private final String CLASS_NAME;
    private final boolean CALL_BACK_NOW;
    private CoordinateBean COORDINATE_BEAN;
    private final boolean NO_NAVIGATION_BAR;


    protected NoTouchParam(Builder builder){
        SPECIAL_FLAG = builder.mSpecialFlag;
        FOCUS_STATUS = builder.mFocusStatus;
        CLASS_NAME = builder.mClassName;
        CALL_BACK_NOW = builder.mCallBackNow;
        NO_NAVIGATION_BAR = builder.mNoNavigationBar;
        if(builder.mCoordinateBean != null){
            COORDINATE_BEAN = builder.mCoordinateBean.copyCoordinate();
        }else{
            COORDINATE_BEAN = null;
        }

    }

    public int getFocusStatus(){
        return FOCUS_STATUS;
    }

    public String getClassName(){
        return CLASS_NAME;
    }


    public int getSpecialFlag(){
        return SPECIAL_FLAG;
    }

    public boolean getCurrentCallBack() {
        return CALL_BACK_NOW;
    }

    public boolean getNoNavigationBar() {
        return NO_NAVIGATION_BAR;
    }

    public CoordinateBean getInitCoordinateBean(){
        return COORDINATE_BEAN;
    }

    public static class Builder{
        private int mSpecialFlag;
        private int mFocusStatus = NoTouchConstant.FocusStatus.NEW;
        private boolean mCallBackNow;
        private String mClassName;
        private CoordinateBean mCoordinateBean;
        private boolean mNoNavigationBar;
        /**
         * {@link com.cneeds.notouch.NoTouchConstant.SpecialFlag}
         * @param specialFlag
         * @return
         */
        public Builder setSpecialFlag(int specialFlag){
            mSpecialFlag = specialFlag;
            return this;
        }
        /**
         * {@link com.cneeds.notouch.NoTouchConstant.FocusStatus}
         * @param focusStatus
         * @return
         */
        public Builder setFocusStatus(int focusStatus){
            mFocusStatus = focusStatus;
            return this;
        }

        public Builder setCallBackNow(boolean nowCallBackNow){
            mCallBackNow = nowCallBackNow;
            return this;
        }

        public Builder setClassName(String className){
            mClassName = className;
            return this;
        }

        public Builder setInitCoordinateBean(CoordinateBean coordinateBean){
            mCoordinateBean = coordinateBean;
            return this;
        }

        public Builder setNoNavigationBar(boolean noNavigationBar){
            mNoNavigationBar = noNavigationBar;
            return this;
        }

        public NoTouchParam build(){
            return new NoTouchParam(this);
        }
    }
}
