package com.cneeds.rvhelpers.viewholder;

import android.content.Context;
import android.support.annotation.IdRes;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import com.cneeds.rvhelpers.adapter.GridRecyclerAdapter;

public abstract class BaseViewHolder<T> extends RecyclerView.ViewHolder {

    public BaseViewHolder(Context context, ViewGroup root, int layoutRes) {
        super(LayoutInflater.from(context).inflate(layoutRes, root, false));
    }

    public Context getContext() {
        return itemView.getContext();
    }

    public abstract void bindData(T t, int position, GridRecyclerAdapter adapter);

    protected View getView(@IdRes int ir) {
        return itemView.findViewById(ir);
    }

}